#include <StorageKit.h>
#include <stdlib.h>

#include "attr.h"

const int32 A_NR = 2; // number of TARTS: attributes
const char *names[A_NR] = {"TARTS:type", "TARTS:command"};
const char *defaults[A_NR] = {"0", "echo \"Selected files: \""};

TARTS_attr::TARTS_attr(const char *_path) {
  values = new BString[A_NR];
  path = _path;
  Read();
} 

void TARTS_attr::Read(void) {
  BFile file(path.String(), B_READ_ONLY);
  if (valid = (B_OK == file.InitCheck())) {
    int32 i; attr_info ati; char *buf;
    for(i=0; i<A_NR; i++) {
      if (B_OK == file.GetAttrInfo(names[i], &ati)) {
   	    buf = new char[ati.size];
  	    file.ReadAttr(names[i], B_STRING_TYPE, 0, buf, ati.size);
  	    values[i] = buf;
        delete[] buf; }
      else values[i] = defaults[i];
    }
  }
}

void TARTS_attr::Write(void) {
  BFile file(path.String(), B_WRITE_ONLY);
  if (valid = (B_OK == file.InitCheck())) {
    int32 i;
    for(i=0; i<A_NR; i++) {
  	  file.WriteAttr(names[i], B_STRING_TYPE, 0, values[i].String(),
  	    1 + values[i].Length()); // must not forget the string terminator
    }
  }
}

int32 TARTS_attr::GetType(void) { return atoi(values[0].String()); }

BString TARTS_attr::GetCommand(void) { return values[1]; }

void TARTS_attr::SetValues(int32 type, BString command) {
  delete[] values;
  values = new BString[A_NR];
  values[0] << type;
  values[1] << command;
}
